<?php
namespace Teknisa\CRM\Geral\Services;

use Teknisa\CRM\Geral\Repository\EnviarMensagemRepository;
use Doctrine\ORM\EntityManager;

class EnviarMensagemService {

    /**
     * @var enviarMensagemRepository
     */
    protected $enviarMensagemRepository;

    public function __construct(EntityManager $entityManager, EnviarMensagemRepository $enviarMensagemRepository) {
        $this->entityManager = $entityManager;
        $this->enviarMensagemRepository = $enviarMensagemRepository;
    }

    /**
     * @return int
     */
    public function getEstruturaProcesso($nrorgEstru, $nrprocesso) {
        try{
            $result = $this->enviarMensagemRepository->getEstruturaProcesso($nrorgEstru, $nrprocesso);
            if (count($result[0]) > 0) {
                $nmestruturam = $result[0]['NMFANTASIA'];
                $nmprocesso = $result[0]['NMPROCESSO'];
                return array("NMFANTASIA" => $nmestruturam, "NMPROCESSO" => $nmprocesso);
            } else {
                if(array_key_exists('NMFANTASIA', $result[0])){
                    throw new \Exception("Estrutura do processo não encontrado.'");
                } else if(array_key_exists('NMPROCESSO', $result[0])){
                    throw new \Exception("Nome do processo não encontrado.'");
                } else {
                    throw new \Exception("Nenhum dado encontrado'");
                }
            }
        }
        catch (Exception $e) {
            throw new exception ($e->getMessage());
        }
    }
    public function getOperador($nrorg, $cdoperador) {
        try{
            //$cdoperador = str_pad($cdoperador, 12, '0', STR_PAD_LEFT);
            $result = $this->enviarMensagemRepository->getOperador($nrorg, $cdoperador);
            
            if(!empty($result)){
                if (count($result[0]) > 0) {
                    $nmoperador = $result[0]['NMOPERADOR'];
                    $dsemailoper = $result[0]['DSEMAILOPER'];
                    return array("NMOPERADOR" => $nmoperador, "DSEMAILOPER" => $dsemailoper);
    
                } else {
                    if(array_key_exists('NMOPERADOR', $result[0])){
                        throw new \Exception("Email do operador não encontrado.'");
                    } else if(array_key_exists('DSEMAILOPER', $result[0])){
                        throw new \Exception("Nome do operador não encontrado.'");
                    } else {
                        throw new \Exception("Nenhum dado encontrado'");
                    }
                }
            }
        }
        catch (Exception $e) {
            throw new exception ($e->getMessage());
        }
    }
    
    public function getLogoCliente($nrorg, $cdoperador) {
        try{
            $result = $this->enviarMensagemRepository->getLogoCliente($nrorg, $cdoperador);
            if(!empty($result)){
                if (count($result[0]) > 0) {
                    $logo = $result[0]['DSURLLOGOESTRUTURA'];
                    return $logo;
                } else {
                        return "";
                    }
                }
        }catch (Exception $e) {
            throw new exception ($e->getMessage());
        }
    }

    public function getOperadorParcnegocio($nrorg, $nrparcnegocio) {
        try{
            $result = $this->enviarMensagemRepository->getOperadorParcnegocio($nrorg, $nrparcnegocio);
            if (count($result[0]) > 0) {
                $nmoperador = $result[0]['NMOPERADOR'];
                $dsemailoper = $result[0]['DSEMAILOPER'];
                return array("NMOPERADOR" => $nmoperador, "DSEMAILOPER" => $dsemailoper);
            } else {
                if(array_key_exists('NMOPERADOR', $result[0])){
                    throw new \Exception("Email do operador não encontrado.'");
                } else if(array_key_exists('DSEMAILOPER', $result[0])){
                    throw new \Exception("Nome do operador não encontrado.'");
                } else {
                    throw new \Exception("Nenhum dado encontrado'");
                }
            }
        }
        catch (Exception $e) {
            throw new exception ($e->getMessage());
        }
    }
    
    public function getInterlocutor($nrorg, $nrseqinterlocutor) {
        try{
            $result = $this->enviarMensagemRepository->getInterlocutor($nrorg, $nrseqinterlocutor);
            $result = $result[0];
            if(!empty($result)){
                if (count($result) > 0) {
                    $nmoperador = $result['NMINTERLOCUTOR'];
                    $dsemailoper = $result['EMAILINTERLOC'];
                    return array("NMINTERLOCUTOR" => $nmoperador, "EMAILINTERLOC" => $dsemailoper);
                } else {
                    if(array_key_exists('NMINTERLOCUTOR', $result)){
                        throw new \Exception("Email do interlocutor não encontrado.'");
                    } else if(array_key_exists('EMAILINTERLOC', $result)){
                        throw new \Exception("Nome do interlocutor não encontrado.'");
                    } else {
                        throw new \Exception("Nenhum dado encontrado'");
                    }
                }
            }
        }
        catch (Exception $e) {
            throw new exception ($e->getMessage());
        }
    }
    
    public function getDadosInterlocutor($nrorg, $nrparcnegocio) {
        try{
            $result = $this->enviarMensagemRepository->getDadosInterlocutor($nrorg, $nrparcnegocio);
            if(!empty($result)){
                if (count($result[0]) > 0) {
                    $nmoperador = $result[0]['NMOPERADOR'];
                    $dsemailoper = $result[0]['DSEMAILOPER'];
                    return array("NMOPERADOR" => $nmoperador, "DSEMAILOPER" => $dsemailoper);
                } else {
                    if(array_key_exists('NMOPERADOR', $result[0])){
                        throw new \Exception("Email do interlocutor não encontrado.'");
                    } else if(array_key_exists('DSEMAILOPER', $result[0])){
                        throw new \Exception("Nome do interlocutor não encontrado.'");
                    } else {
                        throw new \Exception("Nenhum dado encontrado'");
                    }
                }
            }
        }
        catch (Exception $e) {
            throw new exception ($e->getMessage());
        }
    }

    public function getOperadorVinculo($nrorg, $nrvinculom) {
        try{
            $result = $this->enviarMensagemRepository->getOperadorVinculo($nrorg, $nrvinculom);
            if (isset($result[0])) {
                if ($result[0] > 0) {
                    if (array_key_exists('NMOPERADOR', $result[0])) {
                        $nmoperador = $result[0]['NMOPERADOR'];
                        $dsemailoper = $result[0]['DSEMAILOPER'];
                        return array("NMOPERADOR" => $nmoperador, "DSEMAILOPER" => $dsemailoper);
                    } else {
                        $nmoperador = $result[0]['NMPRINCIPALPARC'];
                        $dsemailoper = $result[0]['CDCOMUNICAPARC'];
                        return array("NMOPERADOR" => $nmoperador, "DSEMAILOPER" => $dsemailoper);
                    }
                } else {
                    return false;
                }
            } else {
                return false;
            }
        }
        catch (Exception $e) {
            throw new exception ($e->getMessage());
        }
    }
    
    public function getOperadorSuperior($nrorg, $codigo) {
        $operador = $this->getOperador($nrorg, $codigo);
        if(empty($operador)){
            $operador = $this->getDadosInterlocutor($nrorg, $codigo);   
            if(empty($operador)){
               return array();
            }
        }
        $emailOper = $operador['DSEMAILOPER'];
        $boss = $this->enviarMensagemRepository->getOperadorSuperior($emailOper, $nrorg);
        if(!empty($boss)){
            $nmoperador = $boss[0]['NMOPERADOR'];
            $dsemailoper = $boss[0]['DSEMAILOPER'];
        }else{
            return array();
        }
        return array("NMOPERADOR" => $nmoperador, "DSEMAILOPER" => $dsemailoper);
    }
} 