CREATE OR REPLACE TRIGGER LOG_NUTRPROD
AFTER INSERT OR UPDATE OR DELETE
ON NUTRPROD FOR EACH ROW
DECLARE
  V_DESC      VARCHAR2(500);
  V_USUARIO   VARCHAR2(40);
  V_TIPO      VARCHAR2(1);
  V_CHAVE     VARCHAR2(80);
  
  V_NRORG        VARCHAR2(20);
  
  V_DSIP       VARCHAR2(50);
  V_DSUSUARIO  VARCHAR2(50);
  V_DSRDM      VARCHAR2(50);
  V_DSMETODO   VARCHAR2(250);
  V_DSOPERADOR VARCHAR2(12);
BEGIN
  
  --SISTEMAS DELPHI
  WEBTUNNING(V_DSIP, V_DSUSUARIO, V_DSRDM, V_DSMETODO, V_DSOPERADOR);
  V_CHAVE := :OLD.CDPRODUTO;  
  NMUSUARIO(V_USUARIO); --SISTEMA BROWSER NO GRAVA
    
  IF DELETING THEN
    V_DESC := 'Produto: ' || :OLD.CDPRODUTO;
    V_DESC := V_DESC || ' Cod.Nutriente: ' || :OLD.CDNUTRIENTE;
    V_DESC := V_DESC || ' Qtd/100g: ' || REPLACE(:OLD.QTNUTRPROD, ',', '.');
    V_DESC := V_DESC || ' Fonte: ' || :OLD.DSFONTNUTR;
    V_DESC := V_DESC || ' Dt ltima Atualizacao: ' || :OLD.DTULTATUNUPR;
    
    V_TIPO := '3';
  ELSE
      IF UPDATING THEN
        V_DESC := 'Produto: ' || :OLD.CDPRODUTO;
        V_DESC := V_DESC || ' Cod.Nutriente: ' || :OLD.CDNUTRIENTE || ' | ' || :NEW.CDNUTRIENTE;
        V_DESC := V_DESC || ' Qtd/100g: ' || :OLD.QTNUTRPROD || ' | ' || :NEW.QTNUTRPROD;
        V_DESC := V_DESC || ' Fonte: ' || :OLD.DSFONTNUTR || ' | ' || :NEW.DSFONTNUTR;
        V_DESC := V_DESC || ' Dt ltima Atualizacao: ' || :OLD.DTULTATUNUPR || ' | ' || :NEW.DTULTATUNUPR;      
        
        V_TIPO := '2';
        IF (V_USUARIO = 'VIA BD' AND NVL(:OLD.DTULTATUNUPR, '09/09/1989') <> NVL(:NEW.DTULTATUNUPR, '09/09/1989')) THEN 
          V_USUARIO := :NEW.CDOPERULTATU;
        END IF;
      ELSE
        V_DESC := 'Produto: ' || :NEW.CDPRODUTO;
        V_DESC := V_DESC || ' Cod.Nutriente: ' || :NEW.CDNUTRIENTE;
        V_DESC := V_DESC || ' Qtd/100g: ' || :NEW.QTNUTRPROD;
        V_DESC := V_DESC || ' Fonte: ' || :NEW.DSFONTNUTR;
        V_DESC := V_DESC || ' Dt ltima Atualizacao: ' || :NEW.DTULTATUNUPR;
        
        V_TIPO := '1';
        V_CHAVE := :NEW.CDPRODUTO;
        IF (V_USUARIO = 'VIA BD' OR :NEW.CDOPERINCLUSAO = '1') THEN 
          V_USUARIO := :NEW.CDOPERINCLUSAO;
        END IF;
      END IF;
      
  END IF;

  INSERT INTO LOGOPERA
    (NMTABELA, DTOPERACAO, NMRESPOPER, IDTIPOOPER, CDPESQITEM, DSOPERACAO, DTULTATU,
     DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER)
  VALUES
    ('NUTRPROD', SYSDATE, V_USUARIO, V_TIPO, V_CHAVE, V_DESC, SYSDATE,
     V_DSRDM, V_DSIP, V_DSUSUARIO, V_DSMETODO, V_DSOPERADOR);
END;
/
-- VERSAO --
BEGIN ATUVEROBJ('LOG_NUTRPROD','6.19.xxx'); END;
/