function LoginProductController(ApplicationContext, eventAggregator, Query, templateManager, RepositoryFactory, ScreenService, localStorageEngine, Dashboard_Controller, General)
{
    var self = this;
    
    
    var setParameters = function(session) {
        
        var operatorName = session.user ? session.user.nmoperador : session.nmoperador;
        var orgName = session.user ? session.user.nmorg : session.nmorg;
        
        ScreenService.buildUserData(operatorName, [orgName], function(){
            ScreenService.openWindow('product#crm_profile');
        }, window.defaultUserImageUrl);
        ScreenService.setHeaderInfo(orgName);
    };
    
    var setLocalVars = function(user) {
        
        localStorageEngine.setLocalVar('CRM_CDOPERADOR', user.cdoperador);
        localStorageEngine.setLocalVar('CRM_NRORG', user.nrorg);
        localStorageEngine.setLocalVar('CRM_NRORGTRAB', user.nrorgtrab);
        localStorageEngine.setLocalVar('CRM_CDOPERADOR', user.cdoperador);
        localStorageEngine.setLocalVar('CRM_NMOPERADOR', user.nmoperador);
        localStorageEngine.setLocalVar('CRM_DSEMAILOPER', user.dsemailoper);
        localStorageEngine.setLocalVar('CRM_NRORGPADRAO', 0);
        localStorageEngine.setLocalVar('PROJECT_ID', window.projectId);
        
    };
    
    var setUserID = function(user) {
        //ZhPreferences.setUserID(user.cdoperador);
        if(ApplicationContext.ZhPreferences) {
            ApplicationContext.ZhPreferences.setUserID(user.cdoperador);
        } else {
            ApplicationContext.zhCustomizationsService.registerUser(user.cdoperador);
        }
    };
    
    eventAggregator.subscribe('authSuccess', function(session) {
        var widget;
        
        var user = session.user;
        var cdoperador = user.cdoperador;
        var perfilDeAcesso = user.perfilDeAcesso;

                
        setLocalVars(user);
        setUserID(user);
        setParameters(user);
        setGeneralParameters(user.nrorg);
        
        
        //Zeedhi Access Control
        localStorageEngine.setLocalVar("userId", cdoperador);
        localStorageEngine.setLocalVar("accessProfiles", perfilDeAcesso);
        //localStorageEngine.setLocalVar("productIdLoginUrl", ConfigLogin.loginProductId);
        var interval = setInterval(function() {
            if(!Util.isEmptyOrBlank(templateManager.container) && !Util.isEmptyOrBlank(templateManager.LOGGEDOPERATOR)) {
                clearInterval(interval);
                widget = templateManager.container.getWidget('tabForcaVendas');
                loadGraphics(widget);
            }
        }.bind(this), 1500);
        
    });
    
    
    function getTableByName(tableName, filter) {
        if (!filter) {
            filter = [];
        }
        return General.callRestEngine("product#/crud/" + tableName, "FilterData", filter).then(function (response) {
            var result = [];
            if (response.dataset[tableName])
                result = response.dataset[tableName];
            return result;
        });
    }
    
    function getParamgeral(filtro) {
        return getTableByName("paramgeral", filtro).then(function(response) {
            var paramgeral = null;
            if (response.length)
                paramgeral = response[0];
            return paramgeral;
        });
    }
    
    function setGeneralParameters(nrorg) {
        var filtro = [
            {
                "name": "NRORG",
                "operator": "=",
                "value": nrorg
            }
        ];
        return getParamgeral(filtro).then(function (paramgeral) {
            if (paramgeral) {
                localStorageEngine.setLocalVar('CAD_CDPICTPRAT', replaceMask(paramgeral.CDPICTPRAT, regularExpressions.LETTERS));
                localStorageEngine.setLocalVar('GER_CDPICTPROD', replaceMask(paramgeral.CDPICTPROD, regularExpressions.LETTERS));
                localStorageEngine.setLocalVar('CDPICTPROD', replaceMask(paramgeral.CDPICTPROD, regularExpressions.LETTERS));
                localStorageEngine.setLocalVar('CDPICTCCTB', replaceMask(paramgeral.CDPICTCCTB, regularExpressions.LETTERS));
                localStorageEngine.setLocalVar('GER_CDPICTPRAT', replaceMask(paramgeral.CDPICTPRAT, regularExpressions.LETTERS_AND_NUMBERS));
                localStorageEngine.setLocalVar('CDPICTPRAT', replaceMask(paramgeral.CDPICTPRAT, regularExpressions.LETTERS_AND_NUMBERS));
            } else {
                ScreenService.showMessage("Parâmetros gerais não configurados", "E");
            }
        });
    }
    
    var replaceMask = function(value, regex) {
        return (value || '').toString().replace(regex, '*');
    };
    
    var regularExpressions = {
        LETTERS: /((a|A))/g,
        LETTERS_AND_NUMBERS: /((a|A|9))/g
    };
    
     function loadGraphics(widget) {
        var widName = widget.name;
        
        if (widget.isVisible) {
            if (!Util.isEmptyOrBlank(widget.widgets)) {
                widget.widgets.forEach(function(inWidget) {
                    loadGraphics(inWidget);
                }.bind(this));
            }
            
            widget.dataSourceFilter.forEach(function(dataFilter) {
                if(dataFilter.name == 'P_NRPARCOPERADORES') {
                    dataFilter.value = Dashboard_Controller.getOperatorPropertyIfSetted('NRPARCOPERSHIERARQINF');
                } else if (dataFilter.name == 'CDOPERADOR'){
                    dataFilter.value = Dashboard_Controller.getOperatorPropertyIfSetted('CDOPERADOR');
                } else if (dataFilter.name == 'P_CDOPERSHIERARQINF'){
                    dataFilter.value = Dashboard_Controller.getOperatorPropertyIfSetted('CDOPERSHIERARQINF');
                }
            });
            
            widget.reload();
        }
    };
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('LoginProductController', LoginProductController);
});
