describe("FileTree", function() {

	var root = 'workfolder';
	var mainScripts = [
		{
			"src" : root+"/frameworkFrontend/assets/dist/main.js",
			"relativeUrl": "../../../frameworkFrontend/assets/dist/main.js"
		},
		{
			"src" : root+"/frameworkFrontend/to-distribution/ace.js",
			"relativeUrl":  "../../../frameworkFrontend/to-distribution/ace.js"
		}
	];
	var tree = {};

	beforeEach(function(){
		window.templateUrl = "../../dyman/templates/dyman/";
		window.metadataUrl = "/json_test/test";
		window.serviceUrl = "../backend/service/index.php";    
		module('ZeedhiApp');
		tree = FileTree.build(mainScripts);
	});

	it("File tree should a root and a label using the first path of the mainScripts.", function () {
		expect(Object.keys(tree)[0]).toBe(root);
	});

	it("File tree should a object with showInDevTools by default to be true.", function () {
		expect(tree[root].showInDevTools).toBe(true);
	});

	it("Parent of root should be undefined.", function () {
		expect(tree[root].parent).toBe(undefined);
	});

	it("Url of file tree node should be a string.", function () {
		expect(typeof tree[root].url).toBe("string");
	});

	it("Get only objects in tree should return a array of objects of file tree.", function () {
		var arrayOfKeys = getOnlyObjects(tree);
		var arrayOfKeysMainScript = [];
		for (var key in mainScripts) {
			var objectsInTree = mainScripts[key].src.split('/')[0];
			var sameObject = true;
			arrayOfKeysMainScript.forEach(function(object){
				if(objectsInTree === object){
					sameObject = false;
				} 
			});
			if(sameObject){
				arrayOfKeysMainScript.push(objectsInTree);
			}
		}
		expect(arrayOfKeys.length).toBe(arrayOfKeysMainScript.length);
	});

	it("FileTree unsetParent should remove the parent from object.", function () {
		var obj = {"parent": "father", "sons":{} };
		var arrayTest = "parent";
		expect(FileTree.unsetParent(obj).parent).toBe(undefined);
		expect(FileTree.unsetParent(arrayTest)).toBe("parent")
	});

});
